#include <nds.h>
#include <string.h>
#include "basics.h"
#include "global.h"
#include "time.h"
#include "sprite_red_ball_gfx.h"
#include "sprite_laughing_ball_gfx.h"
#include "laugh.h"
#include "gfx_load.h"
#include "inter_cpus.h"



void slide_sprite (const u16 *sprite_palette, u16 sprite_palette_size,
		   const u8 *sprite_tiles, u16 sprite_nb_tiles)
{
  u16 x ;

  /* Suspension du timer. */
  stop_timer2_no_count_seconds () ;
  // ipc_extension->command = Cmd_micro_off ;

  /* Chargement des connes sprites en mmoire graphique. */
  load_sprites_16
    (SPRITES_SLIDING_LOADING_OFFSET,
     sprite_nb_tiles,
     sprite_tiles,
     SPRITES_SLIDING_PALETTE_SLOT,
     sprite_palette_size,
     sprite_palette,
     Video_sub) ;

  /* Activation du sprite. */
  global_sprites_copy[SPRITES_SLIDING_OAM_ENTRY_INDEX].attribute[0] =
    ATTR0_COLOR_16 | ATTR0_SQUARE |
    (SPRITE_LAUGHING_BALL_Y_POSITION & 0x00FF) ;
  global_sprites_copy[SPRITES_SLIDING_OAM_ENTRY_INDEX].attribute[1] =
    ATTR1_SIZE_64 |
    (SPRITE_LAUGHING_BALL_X_START_POSITION & 0x01FF) ;
  global_sprites_copy[SPRITES_SLIDING_OAM_ENTRY_INDEX].attribute[2] =
    SPRITES_SLIDING_TILE_INDEX | (SPRITES_SLIDING_PALETTE_SLOT << 12) ;
  global_sprites_copy[SPRITES_SLIDING_OAM_ENTRY_INDEX].attribute[3] = 0 ;
  for (x = SPRITES_SLIDING_OAM_ENTRY_INDEX + 1 ; x < 128; x++)
    global_sprites_copy[x].attribute[0] = ATTR0_DISABLED ;
  /* On ne change pas les autres sprites. */

  for (x = SPRITE_LAUGHING_BALL_X_START_POSITION;
       x >= SPRITE_LAUGHING_BALL_X_STOP_POSITION; x -= 2) {
    /* Mise  jour de l'abscisse du sprite. */
    global_sprites_copy[SPRITES_SLIDING_OAM_ENTRY_INDEX].attribute[1] =
      (global_sprites_copy
       [SPRITES_SLIDING_OAM_ENTRY_INDEX].attribute[1] & 0xFF00) |
      (x & 0x00FF) ;
    swiWaitForVBlank () ;
    memcpy
      ((void*) OAM_SUB, (void*) global_sprites_copy,
       128 * sizeof (struct sSpriteEntry)) ;
  }

  /* Dsactivation du sprite en fin. */
  global_sprites_copy[SPRITES_SLIDING_OAM_ENTRY_INDEX].attribute[0] =
    ATTR0_DISABLED ;
  swiWaitForVBlank () ;
  memcpy
    ((void*) OAM_SUB, (void*) global_sprites_copy,
     128 * sizeof (struct sSpriteEntry)) ;

  /* Rtablissement du timer. */
  start_timer2_no_count_seconds () ;
  // ipc_extension->command = Cmd_micro_on ;
}
