#include <nds.h>
#include <nds/arm9/sound.h>
#include <stdlib.h>
#include "basics.h"
#include "persistent.h"
#include "global.h"
#include "gfx_load.h"
#include "printing.h"
#include "large_fonts_gfx.h"
#include "scores_bottom_gfx.h"
#include "scores_top_gfx.h"
#include "scores.h"
#include "wav_screen_touch.h"



static void wait_scores_input ()
{
  keysInit () ;

  for (;;) {
    scanKeys () ;

    if (keysHeld() & (KEY_TOUCH | KEY_START | KEY_A | KEY_B)) {
      playGenericSound (g_wav_screen_touch, WAV_SCREEN_TOUCH_LENGTH) ;
      break ;
    }    /* Fin de if (keysHeld() & (KEY_START | KEY_A | KEY_B)). */
  }      /* fin de for (;;). */

  /* On rinitialise les touches. */
  keysInit () ;
}





void show_scores ()
{
  u16 old_blending_mode, old_blending_mode_sub ;
  short i ;

  /* cran infrieur. */
  load_palette_tile_map_256
    ((u16*) CHAR_BASE_BLOCK_SUB (1),     // TILES (16ko alignes) (adresse)
     (u16*) SCREEN_BASE_BLOCK_SUB (0),   // MAP (2ko aligne) (adresse)
     SCORES_BOTTOM_PALETTE_SIZE,
     scores_bottom_palette,
     NB_SCORES_BOTTOM_TILES,
     scores_bottom_tiles,
     SCORES_BOTTOM_MAP_WIDTH,
     SCORES_BOTTOM_MAP_HEIGHT,
     scores_bottom_map,
     Video_sub) ;

  load_palette_tile_map_16
    ((u16*) CHAR_BASE_BLOCK_SUB (2),     // TILES (16ko alignes) (adresse)
     (u16*) SCREEN_BASE_BLOCK_SUB (1),   // MAP (2ko aligne) (adresse)
     LARGE_FONTS_PALETTE_SLOT,
     LARGE_FONTS_PALETTE_SIZE,
     large_fonts_palette,
     NB_LARGE_FONTS_TILES,
     large_fonts_tiles,
     0,                                  // On construira la map  la pogne.
     0,
     NULL,
     Video_sub) ;

  SUB_BG0_CR =
      BG_MAP_BASE (0)        // Map (pas adresse).
    | BG_TILE_BASE (1)       // Tiles (pas adresse).
    | BG_PRIORITY_3          // Priorit la plus faible.
    | BG_COLOR_256           // 256 couleurs.
    | TEXTBG_SIZE_256x256 ;  // 256 x 256 pixels

  SUB_BG1_CR =
      BG_MAP_BASE (1)        // Map (pas adresse).
    | BG_TILE_BASE (2)       // Tiles (pas adresse).
    | BG_PRIORITY_2          // Priorit moins faible.
    | BG_COLOR_16            // 16 couleurs.
    | TEXTBG_SIZE_256x256 ;  // 256 x 256 pixels


  /* cran suprieur. */
  load_palette_tile_map_256
    ((u16*) CHAR_BASE_BLOCK (1),     // TILES (16ko alignes) (adresse)
     (u16*) SCREEN_BASE_BLOCK (0),   // MAP (2ko aligne) (adresse)
     SCORES_TOP_PALETTE_SIZE,
     scores_top_palette,
     NB_SCORES_TOP_TILES,
     scores_top_tiles,
     SCORES_TOP_MAP_WIDTH,
     SCORES_TOP_MAP_HEIGHT,
     scores_top_map,
     Video_main) ;

  load_palette_tile_map_16
    ((u16*) CHAR_BASE_BLOCK (2),     // TILES (16ko alignes) (adresse)
     (u16*) SCREEN_BASE_BLOCK (1),   // MAP (2ko aligne) (adresse)
     LARGE_FONTS_PALETTE_SLOT,
     LARGE_FONTS_PALETTE_SIZE,
     large_fonts_palette,
     NB_LARGE_FONTS_TILES,
     large_fonts_tiles,
     0,                                  // On construira la map  la pogne.
     0,
     NULL,
     Video_main) ;

  BG0_CR =
      BG_MAP_BASE (0)        // Map (pas adresse).
    | BG_TILE_BASE (1)       // Tiles (pas adresse).
    | BG_PRIORITY_3          // Priorit la plus faible.
    | BG_COLOR_256           // 256 couleurs.
    | TEXTBG_SIZE_256x256 ;  // 256 x 256 pixels

  BG1_CR =
      BG_MAP_BASE (1)        // Map (pas adresse).
    | BG_TILE_BASE (2)       // Tiles (pas adresse).
    | BG_PRIORITY_2          // Priorit moins faible.
    | BG_COLOR_16            // 16 couleurs.
    | TEXTBG_SIZE_256x256 ;  // 256 x 256 pixels

  /* On efface les map destines aux fonts de score  la main. */
  for (i = 0; i < (32 * 24); i++) {
    ((u16*) SCREEN_BASE_BLOCK (1))[i] =
      (u16) (EMPTY_FONT_TILE_INDEX | (LARGE_FONTS_PALETTE_SLOT << 12)) ;
    ((u16*) SCREEN_BASE_BLOCK_SUB (1))[i] =
      (u16) (EMPTY_FONT_TILE_INDEX | (LARGE_FONTS_PALETTE_SLOT << 12)) ;
  }

  for (i = 0; i < NB_HIGHSCORES; i++) {
    large_print_int
      (((u16*) SCREEN_BASE_BLOCK (1)),
       global_highscores.standard[i],
       SCORES_X_OFFSET, (SCORES_Y_OFFSET + (i * 3))) ;
    large_print_int
      (((u16*) SCREEN_BASE_BLOCK_SUB (1)),
       global_highscores.arcade[i],
       SCORES_X_OFFSET, (SCORES_Y_OFFSET + (i * 3))) ; 
  }

  /* Apparition de l'cran en fading. */
  old_blending_mode = BLEND_CR ;
  old_blending_mode_sub = SUB_BLEND_CR ;
  BLEND_Y = 15 ;
  SUB_BLEND_Y = 15 ;
  BLEND_CR = BLEND_FADE_BLACK | BLEND_SRC_BG0 ;
  SUB_BLEND_CR = BLEND_FADE_BLACK | BLEND_SRC_BG0 ;

  videoSetMode (MODE_0_2D | DISPLAY_BG0_ACTIVE | DISPLAY_BG1_ACTIVE) ;
  videoSetModeSub (MODE_0_2D | DISPLAY_BG0_ACTIVE | DISPLAY_BG1_ACTIVE) ;

  for (i = 31; i > 0; i--) {
    swiWaitForVBlank () ;
    BLEND_Y = (u16) (i / 2) ;
    SUB_BLEND_Y = (u16) (i / 2) ;
  }

  BLEND_CR = old_blending_mode ;
  SUB_BLEND_CR = old_blending_mode_sub ;

  /* Attente d'une action. */
  wait_scores_input () ;

  /* Disparition de l'cran en fading. */
  old_blending_mode = BLEND_CR ;
  old_blending_mode_sub = SUB_BLEND_CR ;
  BLEND_Y = 0 ;
  SUB_BLEND_Y = 0 ;
  BLEND_CR = BLEND_FADE_BLACK | BLEND_SRC_BG0 ;
  SUB_BLEND_CR = BLEND_FADE_BLACK | BLEND_SRC_BG0 ;
  for (i = 0; i < 32; i++) {
    swiWaitForVBlank () ;
    BLEND_Y = (u16) (i / 2) ;
    SUB_BLEND_Y = (u16) (i / 2) ;
  }

  BLEND_CR = old_blending_mode ;
  SUB_BLEND_CR = old_blending_mode_sub ;

  videoSetMode (0) ;
  videoSetModeSub (0) ;
}
