#include <nds.h>
#include <interrupts.h>
#include <timers.h>



volatile u32 elapsed_semi_seconds = 0 ;

void timer2_handler ()
{
  /* Interdit les interruptions. */
  REG_IME = IME_DISABLE ;

  elapsed_semi_seconds++ ;

  /* Positionner le flag pour dire que l'on a trait l'interruption. */
  REG_IF |= IRQ_TIMER2 ;

  /* Rtablit les interruptions. */
  REG_IME = IME_ENABLE ;
}


void start_timer2_no_count_seconds ()
{
  TIMER2_DATA = (u16) 0 ;
  /* Frquence pour 0xFFFF correspondant  1 s. */
  TIMER2_CR = TIMER_DIV_256 | TIMER_ENABLE | TIMER_IRQ_REQ ;
  irqEnable (IRQ_TIMER2) ;
}



void stop_timer2_no_count_seconds ()
{
  TIMER2_CR &= (~(TIMER_ENABLE | TIMER_IRQ_REQ)) ;
  irqDisable (IRQ_TIMER2) ;
}


void start_game_timer ()
{
  TIMER2_DATA = (u16) 0 ;
  TIMER3_DATA = (u16) 0 ;
  /* Frquence pour 0xFFFF correspondant  1 s. */
  TIMER2_CR = TIMER_DIV_256 | TIMER_ENABLE | TIMER_IRQ_REQ ;
  /* Timer en cascade pour tester x overflows du timer 2 (=x secondes). */
  TIMER3_CR = TIMER_CASCADE | TIMER_ENABLE ;
}




void stop_game_timer ()
{
  /* Arrt du timer. */
  TIMER2_CR &= (~(TIMER_ENABLE | TIMER_IRQ_REQ)) ;
  TIMER3_CR &= (~(TIMER_ENABLE | TIMER_IRQ_REQ)) ;
}



void suspend_game_timer ()
{
  TIMER2_DATA &= (~TIMER_ENABLE) ;
}



void restart_game_timer ()
{
  TIMER2_DATA |= TIMER_ENABLE ;
}

